' Sprite Trans.bas  clean
#COMPILE EXE
DEFLNG I - N
#INCLUDE "Win32API.inc"



 GLOBAL hWin AS DWORD


'dialog screen size
%w_wide = 440
%w_high = 380



'sprite type; expandable by user
TYPE sprite
    Merge AS DWORD
    Mask  AS DWORD
    high  AS LONG
    wide  AS LONG
    xpos  AS LONG
    ypos  AS LONG
    xdir  AS LONG
    ydir  AS LONG
    skip  AS LONG
END TYPE





'==================================
FUNCTION PBMAIN () AS LONG
      DispMainDialog
END FUNCTION


'====================================
SUB DispMainDialog
    LOCAL bg_bmp AS DWORD
    LOCAL ball() AS sprite
    LOCAL sTemp AS STRING
    LOCAL hDC AS LONG

    ' if this is commented off then it would display a continous
    ' strings of balls
      background_setup bg_bmp

    RANDOMIZE TIMER
    ' Note that no caption will mean no title bar  %SS_NOTIFY
    GRAPHIC WINDOW NEW "", 300, 200, %w_wide, %w_high TO hWin
    GRAPHIC ATTACH hWin, 0
    GRAPHIC CLEAR %RGB_HONEYDEW


    GRAPHIC ATTACH hWin, 0
    GRAPHIC COPY bg_bmp, 0


    sprite_setup ball()
    GRAPHIC ATTACH hWin, 0
    FOR I = 0 TO UBOUND(Ball)
      GRAPHIC COPY Ball(I).Merge, 0 TO (Ball(I).Xpos, Ball(I).Ypos), %MIX_MERGESRC
      GRAPHIC COPY Ball(I).Mask, 0 TO (Ball(I).Xpos, Ball(I).Ypos), %MIX_MASKSRC
    NEXT I


    GRAPHIC DETACH

  ' display the text labels -- if commented off we can exit
  ' the program using the ESC key
    'ShowLabels

    DO
        SLEEP 1
        GRAPHIC ATTACH hWin, 0
        DrawFixLabels

       'if a key is pressed - exit the program
        GRAPHIC INKEY$ TO sTemp
        IF LEN(sTemp) >= 1 THEN
             GRAPHIC WINDOW END
              EXIT LOOP
        END IF
        IF ASC(sTemp)= 27 THEN
          '  exit if ESCAPE key is pressed
            GRAPHIC WINDOW END
            EXIT LOOP
        END IF

        'GRAPHIC DETACH

        'update sprites
        sprite_update ball()
        DrawFixLabels

        'update screen
        screen_update(hWin, bg_bmp, ball())
        DrawFixLabels
        IF ISWIN(hWin) = 0 THEN
             GRAPHIC WINDOW END
             EXIT LOOP
        END IF

        'reduce CPU resource consumption
        SLEEP 1

       'if hDC becomes 0, program is closing
        GRAPHIC GET DC TO hDC
  LOOP UNTIL hDC = 0
END SUB





'================================
' Draws the labels
SUB DrawFixLabels
  GRAPHIC ATTACH hWin, 0

    LOCAL  hFONT_bold AS DWORD
    ' Bold font for the label
    FONT END hFONT_bold
    FONT NEW "Arial",9,1 TO hFONT_bold
    GRAPHIC SET FONT  hFONT_bold


  ' the -2 makes the label background transparent
  GRAPHIC COLOR  %RGB_DARKGREEN, -2    '%RGB_HONEYDEW            '-1, -2
  GRAPHIC SET POS (45, 80)
  GRAPHIC PRINT "This is fixed Label 1 but it does NOT flicker **** "

  GRAPHIC COLOR  %RGB_DARKGREEN,%RGB_HONEYDEW
  GRAPHIC SET POS (45, 120)
  GRAPHIC PRINT "This is fixed Label 2 and this label flickers  "

  GRAPHIC COLOR  %RGB_DARKGREEN,-2
  GRAPHIC SET POS (45, 160)
  GRAPHIC PRINT "This is fixed Label 3 and this label flickers  "

  GRAPHIC COLOR  %RGB_DARKGREEN, -2
  GRAPHIC SET POS (45, 200)
  GRAPHIC PRINT "This is fixed Label 4 and this label flickers  "

  ' clean up
  FONT END hFONT_bold

END SUB






'=====================================
' draw the background graphic
SUB background_setup(hbmp AS DWORD)
    LOCAL  x, y AS LONG
    GRAPHIC BITMAP NEW %w_wide, %w_high TO hbmp
    GRAPHIC ATTACH hbmp, 0
    GRAPHIC CLEAR %RGB_HONEYDEW

     GRAPHIC DETACH
END SUB


'========================================
SUB sprite_setup(mobs() AS sprite)
LOCAL itr8, shadow, shine, bmpindex, color_red, color_green,_
       color_blue, color_show, offset, limit AS LONG
limit = 64 - 1
shine = 20
REDIM mobs(5)
FOR bmpindex = 0 TO 5
    GRAPHIC BITMAP NEW limit, limit TO mobs(bmpindex).Merge
    GRAPHIC ATTACH mobs(bmpindex).Merge, 0
    GRAPHIC CLEAR %RGB_HONEYDEW

    FOR shadow = 0 TO shine
        offset = shadow * 2
        SELECT CASE bmpindex
            CASE 0
              color_red = 255
              color_green = shadow * 8
              color_blue = shadow * 8

            CASE 1
              color_red = shadow * 8
              color_green = 255
              color_blue = shadow * 8

            CASE 2
              color_red = shadow * 8
              color_green = shadow * 8
              color_blue = 255

            CASE 3
              color_red = 175 + (4*shadow)
              color_green = 175 + (4*shadow)
              color_blue = shadow * 8

            CASE 4
              color_red = 175 + (4*shadow)
              color_green = shadow * 8
              color_blue = 175 + (4*shadow)

            CASE 5
              color_red = shadow * 8
              color_green = 175 + (4*shadow)
              color_blue = 175 + (4*shadow)
        END SELECT

        color_show = RGB(color_red, color_green, color_blue)
        GRAPHIC ELLIPSE (shadow, shadow)-(limit - offset, limit - offset), color_show, color_show
    NEXT
    GRAPHIC DETACH
    mobs(bmpindex).xpos = RND(1, 336)
    mobs(bmpindex).ypos = RND(1, 336)
    mobs(bmpindex).xdir = RND(1, 6)
    mobs(bmpindex).ydir = RND(1, 6)
    mobs(bmpindex).skip = %RGB_HONEYDEW
    mobs(bmpindex).high = limit + 1
    mobs(bmpindex).wide = limit + 1

    CALL CreateBitMapMask(Mobs(bmpindex).Merge, Mobs(bmpindex).Mask, Mobs(bmpindex).Skip)

NEXT
END SUB



'======================================
SUB CreateBitMapMask(MergeHndl AS DWORD, _
    MaskHndl AS DWORD, BYVAL BackColor AS DWORD)

REGISTER I          AS LONG

LOCAL Xwide, _
      Yhigh         AS LONG

LOCAL MergeStr, _
      MaskStr       AS STRING

LOCAL MrgPtr, _
      MskPtr        AS DWORD POINTER

LOCAL BkgPtr        AS BYTE POINTER

GRAPHIC ATTACH MergeHndl, 0
GRAPHIC GET BITS TO MergeStr$

MaskStr$ = MergeStr$

MrgPtr = STRPTR(MergeStr$)
MskPtr = STRPTR(MaskStr$) + 8

' SAME AS BGR(COLOR) BUT
' REQUIRES 1 LESS FUNCTION CALL
BkgPtr = VARPTR(BackColor)
SWAP @BkgPtr[0], @BkgPtr[2]

'  FIRST 8 BYTES OF THE STRING
'  IS THE WIDTH AND HEIGHT OF THE IMAGE
Xwide = @MrgPtr[0]
Yhigh = @MrgPtr[1]

MrgPtr = MrgPtr + 8

' PARSE STRING FOR COLOR VALUES
FOR I = 1 TO Xwide * Yhigh
  IF @MrgPtr = BackColor THEN
    @MrgPtr = %BLACK
  ELSE
    @MrgPtr = %WHITE
  END IF

  IF @MskPtr = BackColor THEN @MskPtr = %WHITE
  MrgPtr = MrgPtr + 4
  MskPtr = MskPtr + 4
NEXT I

GRAPHIC SET BITS MergeStr$

GRAPHIC BITMAP NEW Xwide, Yhigh TO MaskHndl
GRAPHIC ATTACH MaskHndl, 0
GRAPHIC SET BITS MaskStr$
GRAPHIC DETACH

END SUB






'========================================
'this updates sprites; here is where you would put
'all your sprite movements and interactions
SUB sprite_update(mobs() AS sprite)
    LOCAL l_lb, itr8 AS LONG
    l_lb = LBOUND(mobs)

    RANDOMIZE TIMER
    FOR itr8 = UBOUND(mobs) TO l_lb STEP -1
        mobs(itr8).xpos += mobs(itr8).xdir
        mobs(itr8).ypos += mobs(itr8).ydir
        IF mobs(itr8).xpos + Mobs(itr8).Wide > %w_wide THEN mobs(itr8).xdir = RND(-1, -6)
        IF mobs(itr8).ypos + Mobs(itr8).High > %w_high THEN mobs(itr8).ydir = RND(-1, -6)
        IF mobs(itr8).xpos < 0 THEN mobs(itr8).xdir = RND(1, 6)
        IF mobs(itr8).ypos < 0 THEN mobs(itr8).ydir = RND(1, 6)
    NEXT
END SUB


'=================================
'this applies the sprites to the display
SUB screen_update(hwin AS DWORD, bmp AS DWORD, mobs() AS sprite)
    LOCAL target, spritebmp AS STRING, l_lb, itr8 AS LONG
    l_lb = LBOUND(mobs)

    GRAPHIC ATTACH hWin, 0, REDRAW
    GRAPHIC COPY bmp, 0

    FOR itr8 = UBOUND(Mobs) TO l_lb STEP -1
      GRAPHIC COPY Mobs(itr8).Merge, 0 TO (Mobs(itr8).Xpos, Mobs(itr8).Ypos), %MIX_MERGESRC
      GRAPHIC COPY Mobs(itr8).Mask, 0 TO (Mobs(itr8).Xpos, Mobs(itr8).Ypos), %MIX_MASKSRC
    NEXT itr8
  ' Draw the fix labels here
    DrawFixLabels
    GRAPHIC REDRAW
END SUB
